fix pxe server leaving background procs
[automated-distro-installer] / fai-revm
index aa10dfc8eeb18bc9b3f04f9067c4c43ee4736605..6271a36bfa4980f3be53fa0ca4dd1efe977d4141 100755 (executable)
--- a/fai-revm
+++ b/fai-revm
@@ -1,12 +1,33 @@
 #!/bin/bash -l
+# Copyright (C) 2016 Ian Kelling
+
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 set -x
 
-# Assumes pxe config for dhcp has been setup.
+# Note, sometimes shutting down the existing demohost vm
+# fails. Just run again if that happens.
+
 # Deploy fai configuration to faiserver,
 # then start a virtual machine to test the config.
 
+cleanup() { :; }
 set -eE -o pipefail
-trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
+trap 'cleanup; echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
+script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
+
+e() { echo "$*"; "$@"; }
 
 # I had this set false as default before, can't remember why. oh well.
 redeploy=true
@@ -16,13 +37,14 @@ fi
 
 disk_count=2
 
-script_dir=$(dirname $(readlink -f "$BASH_SOURCE"))
 
 if [[ $script_dir == /a/bin/* ]]; then
-    rm -rf /a/tmp/fai2
+    # Copy our script elsewhere so we can develop it
+    # and save it at the same time it's running
+    rm -rf /tmp/faifreeze
     mkdir -p /a/tmp
-    cp -ar /a/bin/fai /a/tmp/fai2
-    exec /a/tmp/fai2/${BASH_SOURCE##*/} "$@"
+    cp -ar /a/bin/fai /tmp/faifreeze
+    exec /tmp/faifreeze/${BASH_SOURCE##*/} "$@"
 fi
 
 cd $script_dir
@@ -34,13 +56,14 @@ is_arch_revm() {
 new_disk=false
 [[ ! $1 ]] || new_disk=true
 
+cleanup() { ./pxe-server :; }
 if is_arch_revm; then
-    ./pxe-server arch &
+    ./pxe-server arch
     sleep 2
     # via osinfo-query os. guessing arch is closest to latest fedora.
     variant=fedora22
 else
-    ./pxe-server fai &
+    ./pxe-server fai
     sleep 2
     if $redeploy; then
         ./fai-redep
@@ -50,7 +73,7 @@ fi
 
 name=demohost
 
-s virshrm $name ||:
+s virshrm $name ||:
 
 
 disk_arg=()
@@ -59,7 +82,7 @@ for ((i=1; i <= disk_count; i++)); do
     disk_arg+=("--disk path=$f")
     if $new_disk || [[ ! -e $f ]]; then
         s rm -f $f
-        s qemu-img create -o preallocation=metadata -f qcow2 $f 20G
+        s qemu-img create -o preallocation=metadata -f qcow2 $f 20G
     fi
 done
 
@@ -72,16 +95,18 @@ fi
 # init_module+0x108/0x1000 [raid6_pq]
 #
 # uniq is to stop gtk-warning spam
-s virt-install --os-variant $variant  -n $name --pxe -r 2048 --vcpus 1 \
+s virt-install --os-variant $variant  -n $name --pxe -r 2048 --vcpus 1 \
   ${disk_arg[*]} -w bridge=br0,mac=52:54:00:9c:ef:ad \
-  --graphics spice,listen=0.0.0.0 $console_arg |& grep -v '^$' | uniq &
+  --graphics spice,listen=0.0.0.0 $console_arg |& grep -v '^ *$' | uniq &
 
 if [[ $SSH_CLIENT ]]; then
     fg
 fi
 
-
+sleep 30
+while ! timeout -s 9 10 ssh root@$name /bin/true; do sleep 5; done
+cleanup() { :; }
+pxe-server :
 if is_arch_revm; then
-    while ! timeout 10 ssh $name /bin/true; do sleep 1; done
     ./arch-init-remote $name
 fi